zoukankan      html  css  js  c++  java
  • OpenCascade Modeling Algorithms Fillets and Chamfers

    Modeling Algorithms Fillets and Chamfers

    造型算法——倒圆与倒角

    eryar@163.com

    一、倒圆Fillet Constructor

    1. BRepFilletAPI_MakeFillet

    使用类BRepFilletAPI_MakeFillet来为形状添加倒圆。倒圆是用光滑面来代替角边。使用方法如下: 

    l 首先,给定一个需要倒圆的形状; 

    l 然后,通过Add方法来添加描述倒圆的参数,倒圆所需的参数包括一个边edge和半径radius。当然,边edge必须由两个面face所共有。倒圆会将原来的边替换成光滑的圆面过渡。 

    l 最后,通过询问结果来执行倒圆操作。 

    注:添加一个倒圆两次并不会出错,因为只保留了最后一次添的倒圆。

    Figure 1. Filleting two edges using radius r1 and r2

    Figure 1. Filleting two edges using radius r1 and r2

    下面给出一个将创建一个倒圆的长方体,其尺寸分别为abc,倒圆半径r。 

    Figure 2. Filleting a box

    Figure 2. Filleting a box

    代码如下所示,创建上图所示的倒圆的长方体的参数分别为: 

    a = 100b = 60c = 80r = 10

    #include <TopoDS_Shape.hxx> 
    #include <TopoDS.hxx> 
    #include <BRepPrimAPI_MakeBox.hxx> 
    #include <TopoDS_Solid.hxx> 
    #include <BRepFilletAPI_MakeFillet.hxx> 
    #include <TopExp_Explorer.hxx> 
    
    TopoDS_Shape FilletedBox(const Standard_Real a, 
          const Standard_Real b, 
          const Standard_Real c, 
          const Standard_Real r) 
    { 
        TopoDS_Solid Box = BRepPrimAPI_MakeBox(a,b,c); 
        BRepFilletAPI_MakeFillet MF(Box); 
    
        // add all the edges to fillet 
        TopExp_Explorer ex(Box,TopAbs_EDGE); 
    
        while (ex.More()) 
        { 
            MF.Add(r,TopoDS::Edge(ex.Current())); 
            ex.Next(); 
        }
        return MF.Shape(); 
    } 

     如下图所示为创建一个半径变化的倒圆操作: 

    Figure 3. Evolutive radius fillet

    Figure 4. Evolutive radius fillet a box

    程序代码如下所示:

      1:     TopoDS_Shape theBox = BRepPrimAPI_MakeBox(200, 200, 200);
    
      2:     BRepFilletAPI_MakeFillet Rake(theBox);
    
      3:     ChFi3d_FilletShape FSH = ChFi3d_Rational;
    
      4:     Rake.SetFilletShape(FSH);
    
      5:  
    
      6:     TColgp_Array1OfPnt2d parAndRad(1, 6);
    
      7:     parAndRad.SetValue(1, gp_Pnt2d(0, 10));
    
      8:     parAndRad.SetValue(2, gp_Pnt2d(50, 20));
    
      9:     parAndRad.SetValue(3, gp_Pnt2d(70, 20));
    
     10:     parAndRad.SetValue(4, gp_Pnt2d(130, 60));
    
     11:     parAndRad.SetValue(5, gp_Pnt2d(160, 30));
    
     12:     parAndRad.SetValue(6, gp_Pnt2d(200, 20));
    
     13:  
    
     14:     TopExp_Explorer ex(theBox, TopAbs_EDGE);
    
     15:     Rake.Add(parAndRad, TopoDS::Edge(ex.Current()));
    
     16:     TopoDS_Shape evolvedBox = Rake.Shape();
    
     17: 

    2. BRepFilletAPI_MakeFillet2d

    BRepFilletAPI_MakeFillet2d is used to construct fillets and chamfers on planar faces

    我按照示例代码运行了一下程序,结果程序总是崩溃,其操作的效果不得而知,所以也得不到真实的效果图。将其程序代码列出如下所示:

      1: #include “BRepPrimAPI_MakeBox.hxx” 
    
      2: #include “TopoDS_Shape.hxx” 
    
      3: #include “TopExp_Explorer.hxx” 
    
      4: #include “BRepFilletAPI_MakeFillet2d.hxx” 
    
      5: #include “TopoDS.hxx” 
    
      6: #include “TopoDS_Solid.hxx” 
    
      7:  
    
      8: TopoDS_Shape FilletFace(const Standard_Real a, 
    
      9:     const Standard_Real b, 
    
     10:     const Standard_Real c, 
    
     11:     const Standard_Real r) 
    
     12: { 
    
     13:     TopoDS_Solid Box = BRepPrimAPI_MakeBox (a,b,c); 
    
     14:     TopExp_Explorer ex1(Box,TopAbs_FACE); 
    
     15:  
    
     16:     const TopoDS_Face& F = TopoDS::Face(ex1.Current()); 
    
     17:     BRepFilletAPI_MakeFillet2d MF(F); 
    
     18:     TopExp_Explorer ex2(F, TopAbs_VERTEX); 
    
     19:  
    
     20:     while (ex2.More()) 
    
     21:     { 
    
     22:         MF.AddFillet(TopoDS::Vertex(ex2.Current()),r); 
    
     23:         ex2.Next(); 
    
     24:     } 
    
     25:  
    
     26:     // while... 
    
     27:     return MF.Shape(); 
    
     28: }
    
     29: 

    二、倒角Chamfer Constructor

    1BRepFilletAPI_MakeChamfer

    BREpFilletAPI_MakeChamfer的使用方法与BRepFilletAPI_MakeFillet大致类似,但稍有不同: 

    a) The surfaces created are ruled and not smooth

    b) The Add syntax for selecting edges requires one or two distances, one edge and one face(contiguous to the edge); 

    Add(dist, E, F); 

    Add(d1, d2, E, F); with d1 on the face F

    Figure 5. Creating a chamfer

    Figure 6. The box with chamfers

    程序代码如下所示:

      1: TopoDS_Shape theBox = BRepPrimAPI_MakeBox(130,200,170); 
    
      2: BRepFilletAPI_MakeChamfer MC(theBox); 
    
      3: TopTools_IndexedDataMapOfShapeListOfShape M; 
    
      4: TopExp::MapShapesAndAncestors(theBox,TopAbs_EDGE,TopAbs_FACE,M); 
    
      5:  
    
      6: for (Standar1d_Integer i;i<M.Extent();i++) 
    
      7: { 
    
      8:     TopoDS_Edge E = TopoDS::Edge(M.FindKey(i)); 
    
      9:     TopoDS_Face F = TopoDS::Face(M.FindFromIndex(i).First()); 
    
     10:     MC.Add(15,15,E,F); 
    
     11: } 
    
     12:  
    
     13: TopoDS_Shape ChanfrenedBox = MC.Shape();  
    
     14: 
  • 相关阅读:
    [Swift通天遁地]八、媒体与动画-(11)实现音乐播放的动态视觉效果
    [Swift通天遁地]八、媒体与动画-(10)在项目中播放GIF动画
    [Swift通天遁地]八、媒体与动画-(9)快速实现复合、Label、延续、延时、重复、缓冲、弹性动画
    [Swift通天遁地]八、媒体与动画-(8)使用开源类库快速实现位移动画
    net location
    移动js
    说说
    jquery mobile script
    jquery script
    保持整洁
  • 原文地址:https://www.cnblogs.com/opencascade/p/3512586.html
Copyright © 2011-2022 走看看